/*
** Copyright (C) 2003 Jesse Chappell <jesse@essej.net>
**  
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**  
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**  
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
**  
*/

#ifndef __FTPROCLIMIT_HPP__
#define __FTPROCLIMIT_HPP__

#include "FTprocI.hpp"

class FTprocLimit
	: public FTprocI
{
  public:

	FTprocLimit(nframes_t samprate, unsigned int fftn);
	FTprocLimit (const FTprocLimit & other);

	virtual ~FTprocLimit();

	FTprocI * clone() { return new FTprocLimit(*this); }
	void initialize();
	
	void process (fft_data *data,  unsigned int fftn);

	virtual bool useAsDefault() { return false; }
	
  protected:

	FTspectrumModifier * _threshfilter;
	float _dbAdjust;
};

#endif
